#pragma once

#include "ros_bridge/include/MessageTag.h"
#include "ros_bridge/rapidjson/include/rapidjson/document.h"

#include <memory>
#include <deque>

namespace ROSBridge {
namespace ComPrivate {

typedef MessageTag Tag;
typedef rapidjson::Document JsonDoc;
typedef std::unique_ptr<JsonDoc> JsonDocUPtr;
typedef std::deque<JsonDocUPtr> JsonQueue;

static const char* _topicAdvertiserKey = "topic_advertiser";
static const char* _topicPublisherKey =  "topic_publisher";
//static const char* _topicAdvertiserKey = "service_advertiser";
static const char* _topicSubscriberKey = "topic_subscriber";

}
}
